// D import file generated from 'tango/core/RuntimeTraits.d'
module tango.core.RuntimeTraits;
const(TypeInfo) realType(const(TypeInfo) type)
{
auto def = cast(TypeInfo_Typedef)type;
if (def !is null)
{
return def.base;
}
else
if (type.classinfo.name.length is 14 && type.classinfo.name[9..$] == "Const" || type.classinfo.name.length is 18 && type.classinfo.name[9..$] == "Invariant" || type.classinfo.name.length is 15 && type.classinfo.name[9..$] == "Shared" || type.classinfo.name.length is 14 && type.classinfo.name[9..$] == "Inout")
{
return (cast(TypeInfo_Const)type).next;
}
return type;
}
const(ClassInfo) asClass(const(TypeInfo) type)
{
if (isInterface(type))
{
auto klass = cast(TypeInfo_Interface)type;
return klass.info;
}
if (isClass(type))
{
auto klass = cast(TypeInfo_Class)type;
return klass.info;
}
return null;
}
bool isDerived(const(ClassInfo) derived, const(ClassInfo) base);
bool implements(const(ClassInfo) implementor, const(ClassInfo) iface);
bool isImplicitly(const(ClassInfo) test, const(ClassInfo) target)
{
return isDerived(test,target) || implements(test,target);
}
bool isImplicitly(const(TypeInfo) test, const(TypeInfo) target)
{
if (test is target)
return true;
if (isStaticArray(test) && isDynamicArray(target) && valueType(test) is valueType(target))
{
return true;
}
auto klass1 = asClass(test);
auto klass2 = asClass(target);
if (isClass(test) && isClass(target))
{
return isDerived(klass1,klass2);
}
if (isInterface(test) && isInterface(target))
{
return isDerived(klass1,klass2);
}
if (klass1 && klass2)
{
return isImplicitly(klass1,klass2);
}
if (klass1 || klass2)
{
return false;
}
if (isSignedInteger(test) && isSignedInteger(target) || isUnsignedInteger(test) && isUnsignedInteger(target) || isFloat(test) && isFloat(target) || isCharacter(test) && isCharacter(target))
{
return test.tsize() <= target.tsize();
}
if (isSignedInteger(test) && isUnsignedInteger(target))
{
return false;
}
if (isUnsignedInteger(test) && isSignedInteger(target))
{
return test.tsize() < target.tsize();
}
return false;
}
const(ClassInfo)[] baseClasses(const(ClassInfo) type);
const(ClassInfo)[] baseInterfaces(const(ClassInfo) type);
const(ClassInfo)[] interfaceGraph(const(ClassInfo) type);
struct applyInterfaces
{
    this(const(ClassInfo) type)
{
this.type = cast()type;
}
    int opApply(scope int delegate(ref ClassInfo) dg);
    ClassInfo type;
}
const(ClassInfo)[] baseTypes(const(ClassInfo) type)
{
if (type is null)
return null;
return baseClasses(type) ~ baseInterfaces(type);
}
ModuleInfo* moduleOf(const(ClassInfo) type);
const(ClassInfo)[] directInterfaces(const(ClassInfo) type);
const(ClassInfo)[] derivedTypes(const(ClassInfo) type);
bool isDynamicArray(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2.classinfo.name[9] == 'A' && type2.classinfo.name.length == 11 || type2.classinfo.name.length == 12 && type2.classinfo.name[9..12] == "Aya" || cast(TypeInfo_Array)type2 !is null;
}
bool isStaticArray(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_StaticArray)type2 !is null;
}
bool isArray(const(TypeInfo) type)
{
auto type2 = realType(type);
return isDynamicArray(type2) || isStaticArray(type2);
}
bool isAssociativeArray(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_AssociativeArray)type2 !is null;
}
bool isCharacter(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2 is typeid(char) || type2 is typeid(wchar) || type2 is typeid(dchar);
}
bool isString(const(TypeInfo) type)
{
auto type2 = realType(type);
return isArray(type2) && isCharacter(valueType(type2));
}
bool isUnsignedInteger(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2 is typeid(uint) || type2 is typeid(ulong) || type2 is typeid(ushort) || type2 is typeid(ubyte);
}
bool isSignedInteger(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2 is typeid(int) || type2 is typeid(long) || type2 is typeid(short) || type2 is typeid(byte);
}
bool isInteger(const(TypeInfo) type)
{
auto type2 = realType(type);
return isSignedInteger(type2) || isUnsignedInteger(type2);
}
bool isBool(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2 is typeid(bool);
}
bool isFloat(const(TypeInfo) type)
{
auto type2 = realType(type);
return type2 is typeid(float) || type2 is typeid(double) || type2 is typeid(real);
}
bool isPrimitive(const(TypeInfo) type)
{
auto type2 = realType(type);
return isArray(type2) || isAssociativeArray(type2) || isCharacter(type2) || isFloat(type2) || isInteger(type2);
}
bool isInterface(const(TypeInfo) type)
{
return cast(TypeInfo_Interface)type !is null;
}
bool isPointer(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_Pointer)type2 !is null;
}
bool isClass(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_Class)type2 !is null;
}
bool isStruct(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_Struct)type2 !is null;
}
bool isFunction(const(TypeInfo) type)
{
auto type2 = realType(type);
return cast(TypeInfo_Function)type2 !is null || cast(TypeInfo_Delegate)type2 !is null;
}
bool isReferenceType(const(TypeInfo) type)
{
return isClass(type) || isPointer(type) || isDynamicArray(type);
}
bool isUserDefined(const(TypeInfo) type)
{
return isClass(type) || isStruct(type);
}
bool isValueType(const(TypeInfo) type)
{
return !(isDynamicArray(type) || isAssociativeArray(type) || isPointer(type) || isClass(type) || isFunction(type));
}
const(TypeInfo) keyType(const(TypeInfo) type)
{
auto type2 = realType(type);
auto assocArray = cast(TypeInfo_AssociativeArray)type2;
if (assocArray)
return assocArray.key;
if (isArray(type2))
return typeid(size_t);
return null;
}
const(TypeInfo) valueType(const(TypeInfo) type)
{
auto type2 = realType(type);
if (isArray(type2))
return type2.next;
auto assocArray = cast(TypeInfo_AssociativeArray)type2;
if (assocArray)
return assocArray.value;
auto pointer = cast(TypeInfo_Pointer)type2;
if (pointer)
return pointer.m_next;
return null;
}
const(TypeInfo) returnType(const(TypeInfo) type)
{
auto type2 = realType(type);
auto delegat = cast(TypeInfo_Delegate)type2;
if (delegat)
return delegat.next;
auto func = cast(TypeInfo_Function)type2;
if (func)
return func.next;
return null;
}
debug (UnitTest)
{
    interface I1
{
}
    interface I2
{
}
    interface I3
{
}
    interface I4
{
}
    class A
{
}
    class B : A,I1
{
}
    class C : B,I2,I3
{
}
    class D : A,I1
{
    int foo(int i)
{
return i;
}
}
    struct S1
{
}
            }
